import 'package:cached_network_image/cached_network_image.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

class DefaultImageView extends StatefulWidget {

  final String imageUrl;
  final double size;


  DefaultImageView({
    this.imageUrl,
    this.size
  });

  @override
  _DefaultImageView createState() => _DefaultImageView();

}

class _DefaultImageView extends State<DefaultImageView> {
  @override
  Widget build(BuildContext context) {
    // TODO: implement build
    return widget.imageUrl == null ?
    Container(
      alignment: Alignment.center,
      child: Icon(Icons.cloud_download),
    ) :
    CachedNetworkImage(
        imageUrl: widget.imageUrl,
        fit: BoxFit.cover,
        placeholder: (context, url) => Container(
          width: widget.size == null ? 48 : widget.size,
          height: widget.size == null ? 48 : widget.size,
          color: Colors.white,
          padding: const EdgeInsets.all(8),
          child: Icon(Icons.file_download),
        ),
        errorWidget: (context, url, error) => Container(
          width: widget.size == null ? 48 : widget.size,
          height: widget.size == null ? 48 : widget.size,
          padding: const EdgeInsets.all(8),
          child: Icon(Icons.insert_drive_file),
        )
    );
  }
}